VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Subclasser"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Event EventReceived(ByVal msg As Long, ByVal lParam As Long, ByVal wParam As Long, ByRef process_event As Boolean)

Private m_hWnd As Long
' Process the message.
Public Function WindowProc(ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Const WM_NCDESTROY = &H82
Dim process_event As Boolean

    ' Raise the EventReceived event.
    process_event = True
    RaiseEvent EventReceived(msg, lParam, wParam, process_event)

    ' Process the event normally.
    If process_event Then
        WindowProc = CallWindowProc( _
            OldWindowProcs(Str$(m_hWnd)), _
            m_hWnd, msg, wParam, lParam)
    End If

    ' If we're being destroyed, unsubclass.
    If msg = WM_NCDESTROY Then UnSubclass
End Function
' Subclass this window.
Public Sub Subclass(ByVal hWnd As Long)
    ' Make sure the collections are allocated.
    If OldWindowProcs Is Nothing Then
        Set OldWindowProcs = New Collection
        Set Subclassers = New Collection
    End If

    ' If we already represent a subclassed window,
    ' unsubclass it.
    If m_hWnd <> 0 Then UnSubclass
    m_hWnd = hWnd

    ' Subclass, saving the old WindowProc
    ' with the hWnd as key.
    OldWindowProcs.Add _
        SetWindowLong( _
            hWnd, GWL_WNDPROC, _
            AddressOf NewWindowProc), Str$(m_hWnd)

    ' Save a reference to ourself
    ' with the hWnd as key.
    Subclassers.Add Me, Str$(m_hWnd)
End Sub
' Unsubclass this hWnd.
Public Sub UnSubclass()
    ' Do nothing if we aren't subclassing.
    If m_hWnd = 0 Then Exit Sub

    ' Restore the original WindowProc.
    SetWindowLong _
        m_hWnd, GWL_WNDPROC, _
        OldWindowProcs(Str$(m_hWnd))

    ' Remove the original WindowProc and ourself
    ' from the collections.
    OldWindowProcs.Remove Str$(m_hWnd)
    Subclassers.Remove Str$(m_hWnd)
    m_hWnd = 0
End Sub
